/*
 * nst	This file simple check if stat of one port is listen.
 *
 * Version:	@(#)nst.c	0.5	04/02/97
 *
 * Author:	Nelson Murilo, <nelson@pangeia.com.br>
 *
 *		Copyright (c) 1995-97  Pangeia Informatica Ltda.
 *
 */
#include <stdio.h>
#include <netinet/in.h>
#include <linux/tcp.h>

#define _PATH_PROCNET_TCP	"/proc/net/tcp"
#define E_READ  -1
#define PORT 6013

char nst_rcsid[] = 
  "$Id: nst.c,v 0.5 1997/04/02 00:42:46 nmor Exp $";
char *Release = "NST",
     *Version = "@(#)nst.c 0.5 (04/02/97)";
#define Signature "(c) 1997, Nelson Murilo <nelson@pangeia.com.br>"

FILE *procinfo;

int main(argc, argv)
int argc; char **argv;
{
   int port = PORT;

   char buffer[8192], local_addr[128];
   char rem_addr[128], *tcp_state, timers[64];
   struct sockaddr_in localaddr, remaddr;
   unsigned long rxq, txq, time_len, retr;
   int num, local_port, rem_port, d, state;
   int uid, timer_run, lnr = 0;

   if (argc > 2 || (argc == 2 && (port = atoi(argv[1])) < 1 ))
   {
      fprintf (stderr, "Usage: nst [port]\n");
      exit(2);
   }
   
   
   if ((procinfo = fopen(_PATH_PROCNET_TCP, "r")) == NULL) 
   {
      perror(_PATH_PROCNET_TCP);
      return(E_READ);
   }

   fgets(buffer, sizeof(buffer), procinfo);
   while (!feof(procinfo)) 
   {
      fgets(buffer, sizeof(buffer), procinfo);
      num = sscanf(buffer,
               "%d: %lX:%X %lX:%X %X %X:%X %X:%lX %lX %d\n",
                &d, &localaddr.sin_addr.s_addr, &local_port,
                &remaddr.sin_addr.s_addr, &rem_port, &state,
                &txq, &rxq, &timer_run, &time_len, &retr, &uid);
      if (local_port == port)
      {
         printf(" Port %d ", port);
         switch (state) 
         {
            case TCP_ESTABLISHED:
               printf("ESTABLISHED\n");
	       break;

            case TCP_SYN_SENT:
               printf("SYN_SENT\n");
               break;

            case TCP_SYN_RECV:
               printf("SYN_RECV\n");
               break;

            case TCP_FIN_WAIT1:
               printf("FIN_WAIT1\n");
               break;

            case TCP_FIN_WAIT2:
               printf("FIN_WAIT2\n");
               break;

            case TCP_TIME_WAIT:
               printf("TIME_WAIT\n");
               break;

            case TCP_CLOSE:
               printf("CLOSE\n");
               break;
#ifdef TCP_CLOSING
            case TCP_CLOSING:
               printf("CLOSING\n");
               break;
#endif
            case TCP_CLOSE_WAIT:
               printf( "CLOSE_WAIT\n");
               break;

            case TCP_LAST_ACK:
               printf( "LAST_ACK\n");
               break;

            case TCP_LISTEN:
               printf( "LISTEN\n");
               break;

            default:
               printf( "?? ()\n");
               break;
         }
         exit (1);
      }
   }
   (void) fclose(procinfo);
   printf ("port %d listless \n", port);
   exit(0);
}
